---
title: ResizeObserver
slug: Web/API/ResizeObserver
tags:
  - API
  - Bounding Box
  - Experimental
  - Interface
  - Reference
  - Resize Observer API
  - ResizeObserver
  - content box
  - observers
---
<div>{{APIRef("Resize Observer API")}}</div>

<p class="summary">The <strong><code>ResizeObserver</code></strong> interface reports changes to the dimensions of an {{domxref('Element')}}'s content or border box, or the bounding box of an {{domxref('SVGElement')}}.</p>

<div class="notecard note">
<p class="summary"><strong>Note</strong>: The content box is the box in which content can be placed, meaning the border box minus the padding and border width. The border box encompasses the content, padding, and border. See <a href="/en-US/docs/Learn/CSS/Building_blocks/The_box_model">The box model</a> for further explanation.</p>
</div>

<p><code>ResizeObserver</code> avoids infinite callback loops and cyclic dependencies that are often created when resizing via a callback function. It does this by only processing elements deeper in the DOM in subsequent frames. Implementations should, if they follow the specification, invoke resize events before paint and after layout.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ResizeObserver.ResizeObserver", "ResizeObserver()")}}</dt>
 <dd>Creates and returns a new <code>ResizeObserver</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('ResizeObserver.disconnect()')}}</dt>
 <dd>Unobserves all observed {{domxref('Element')}} targets of a particular observer.</dd>
 <dt>{{domxref('ResizeObserver.observe()')}}</dt>
 <dd>Initiates the observing of a specified {{domxref('Element')}}.</dd>
 <dt>{{domxref('ResizeObserver.unobserve()')}}</dt>
 <dd>Ends the observing of a specified {{domxref('Element')}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="https://mdn.github.io/dom-examples/resize-observer/resize-observer-text.html">resize-observer-text.html</a> (<a href="https://github.com/mdn/dom-examples/blob/master/resize-observer/resize-observer-text.html">see source</a>) example, we use the resize observer to change the {{cssxref("font-size")}} of a header and paragraph as a slider’s value is changed causing the containing <code>&lt;div&gt;</code> to change width. This shows that you can respond to changes in an element’s size, even if they have nothing to do with the viewport.</p>

<p>We also provide a checkbox to turn the observer off and on. If it is turned off, the text will not change in response to the <code>&lt;div&gt;</code>'s width changing.</p>

<p>The JavaScript looks like so:</p>

<pre class="brush: js notranslate">const h1Elem = document.querySelector('h1');
const pElem = document.querySelector('p');
const divElem = document.querySelector('body &gt; div');
const slider = document.querySelector('input[type="range"]');
const checkbox = document.querySelector('input[type="checkbox"]');

divElem.style.width = '600px';

slider.addEventListener('input', () =&gt; {
  divElem.style.width = slider.value + 'px';
})

const resizeObserver = new ResizeObserver(entries =&gt; {
  for (let entry of entries) {
    if(entry.contentBoxSize) {
      // Checking for chrome as using a non-standard array
      if (entry.contentBoxSize[0]) {
        h1Elem.style.fontSize = Math.max(1.5, entry.contentBoxSize[0].inlineSize/200) + 'rem';
        pElem.style.fontSize = Math.max(1, entry.contentBoxSize[0].inlineSize/600) + 'rem';
      } else {
        h1Elem.style.fontSize = Math.max(1.5, entry.contentBoxSize.inlineSize/200) + 'rem';
        pElem.style.fontSize = Math.max(1, entry.contentBoxSize.inlineSize/600) + 'rem';
      }
    } else {
      h1Elem.style.fontSize = Math.max(1.5, entry.contentRect.width/200) + 'rem';
      pElem.style.fontSize = Math.max(1, entry.contentRect.width/600) + 'rem';
    }
  }
  console.log('Size changed');
});

resizeObserver.observe(divElem);

checkbox.addEventListener('change', () =&gt; {
  if (checkbox.checked) {
    resizeObserver.observe(divElem);
  } else {
    resizeObserver.unobserve(divElem);
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Resize Observer','#resize-observer-interface','ResizeObserver')}}</td>
   <td>{{Spec2('Resize Observer')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ResizeObserver")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/CSS/Building_blocks/The_box_model">The box model</a></li>
 <li>{{domxref('PerformanceObserver')}}</li>
 <li>{{domxref('IntersectionObserver')}} (part of the <a href="/en-US/docs/Web/API/Intersection_Observer_API">Intersection Observer API</a>)</li>
</ul>
